
|---------------------------------------------------------------------------
|
| DataBoard driver
| ----------------
|
| Minor nummer:   Bit 7, 6	Anv{nds ej
|		  Bit 5..0	Kort adress
|
|
| H}rdvaru beskrivning av DataBoard interface i X37'an:
|
| Basadressen f|r DataBoard korten {r:	  		0xfe0001
| P} korten kan adressen 0..63 v{ljas, dvs 6 bitar.
| Dessa 6 bitar {r placerade enligt masken		0x01f800
|
| Detta ger basadresser inom arean 0xfe0001 - 0xfff801.
|
| Offsets inom varje basadress som skriver/l{ser p} DataBoard kort:
|
|	SKRIV	0x00	OUT*
|		0x04	---
|		0x08	C1*
|		0x0c	C2*
|		0x10	C3*
|		0x14	C4*
|
|	L[S	0x00	INP*
|		0x04	STAT*
|		0x08	OPS*	Optional Status register
|
| Dessutom finns ytterligare offsets f|r register:
|
|	L[S	0x40	CSB registret i X37'an
|			  bit 6 = XCSB5*
|			  bit 4 = CSBP3*
|			  bit 2 = CSBP4*
|			  bit 1 = XCSB2*
|			  |vriga bitar {r alltid ettor
|			  Om inget kort genererar CSB* {r alla bitar ettor
|
|	L[S	0x50	EXPansion read cycle, register i exp kabel ????
|
|-------------------------------------------------------------------------

| Anv{nda adresser

XPAGE	=	0x3a8800
YPAGE	=	0x3a9000
XPAGEA	=	0xba8880
DBbaseadr =	0xfe0001	| Basadress f|r DataBoard korten


|-------------------------------------------------------------------------
| _dbopen()
|
| Parametrar vid anrop (efter link a6..):
|

	.globl	_dbopen
_dbopen:
	link	a6,#0x0
	unlk	a6
	rts


|-------------------------------------------------------------------------
| _dbclose()
|
| Parametrar vid anrop (efter link a6..):
|

	.globl	_dbclose
_dbclose:
	link	a6,#0x0
	unlk	a6
	rts


|-------------------------------------------------------------------------
| _dbstrategy()
|
| Parametrar vid anrop (efter link a6..):
|	0x8(a6)		IO req block
|
| Lokala parametrar
|	0xfffe(a6)	
|	0xffff(a6)
|

	.globl	_dbstrategy
_dbstrategy:
	link	a6,#0xfffc
	moveml	#0x304,-(sp)		| d6 d7 a5

	movl	0x8(a6),a5		| IO req block

	btst	#0,0x25(a5)		| J{mn adress i dest/k{lla ?
	bnes	TS4061			| Nej, Avsluta med fel -5

	cmpl	#0x2,0x22(a5)		| [r beg{rd l{ngd < 2 ?
	bcss	TS4061			| Ja, Avsluta med fel -5

	cmpb	#0x5,0x47(a5)		| 
	bnes	TS4061			| Avsluta med fel -5

	moveq	#0x2,d0
	movl	d0,-(sp)		| 2
	pea	0xfffe(a6)		|
	movl	0x1e(a5),-(sp)		| Destination/K{lla 
	bsr	_copy_ms
	addw	#0xc,sp

	cmpb	#0x11,0xfffe(a6)
	bnes	TS4061			| Avsluta med fel -5

	movb	0xffff(a6),d0		| minor nummer
	andl	#0x3f,d0		| maska fram adressen
	movl	d0,d7

	| Ber{kna kort adressen
	moveq	#0xb,d1
	asll	d1,d0			| Adress bitarna {r 01f800
	orl	#DBbaseadr,d0		| Maska in basadressen
	movl	d0,a0

	movb	0x40(a0),d0		| L{s av CSB register
	notb	d0			| Finns det n}got kort p} adressen ?
	beqs	TS4061			| Nej, Avsluta med fel -5

	| Ber{kna kort adressen
	movl	d7,d0			| Adress del av minor nummer
	moveq	#0xb,d1
	asll	d1,d0			| Adress bitarna {r 01f800
	orl	#DBbaseadr,d0		| Maska in basadressen
	movl	d0,a0

	movb	0x40(a0),d0		| L{s av CSB register
	notb	d0			| Maska fram CSB bitarna
	andl	#0xff,d0

	| Konvertera masken till bit nummer
	movl	d0,-(sp)
	jsr	_masktobn
	addql	#4,sp

	| Returnerar bit nummer eller -1 om fel
	| Bit nummret ger vilken signal som var aktiverad
	| Om -1 returnerades, var flera signaler aktiverade

	movl	d0,d6			| Spara resultatet

	bges	TS4066			| Hoppa om konvertering OK


	| Avsluta med fel -5 
TS4061:
	movw	#0xfffb,0x36(a5)	| -5 

	bset	#2,0x6d(a5)

TS4074:
	pea	(a5)
	jsr	_iodone
	addql	#4,sp

TS4076:
	moveml	(sp)+,#0x20c0		| d6 d7 a5
	unlk	a6
	rts


|-------------------------------------------------------------------------
| _dbintr()
|
| Parametrar vid anrop (efter link a6..):
|	0x8(a6)		Driver data
|
| Driver data:
|	bit 31..16	W	0
|	bit 15..8	B	Adress del av minor nummer
|	bit 7..0	B	Bit nummer som kortets CSB signal kommer p}
|

_dbintr:
	link	a6,#0xfffc
	moveml	#0x304,-(sp)		| d6 d7 a5

	movl	0x8(a6),d0		| Las driver data
	asrl	#8,d0			| Ber{kna adress del av minor nummer
	movl	d0,d7

	movl	0x8(a6),d0		| Las driver data
	andl	#0xff,d0		| Maska fram bit nummer som kortets
	movl	d0,d6			|  CSB signal kommer p}

	movl	d6,d0			
	asll	#2,d0
	addl	#_dbrnt,d0
	movl	d0,a0

	movl	(a0),a5			| H{mta IO Req Block
	movl	a5,d0
	bne	TS4077

	| Ber{kna kort adress
	movl	d7,d0			| Adress del av minor nummer
	moveq	#0xb,d1
	asll	d1,d0			| Adress bitarna {r 01f800
	orl	#DBbaseadr,d0		| Maska in basadress
	movl	d0,a0

	clrb	0x14(a0)		| Skriv till register C4* p} kortet

	| Ber{kna kort adress
	movl	d7,d0			| Adress del av minor nummer
	moveq	#0xb,d1
	asll	d1,d0			| Adress bitarna {r 01f800
	orl	#DBbaseadr,d0		| Maska in basadress
	movl	d0,a0

	movb	0x4(a0),0xffff(a6)	| L{s av register STAT* p} kortet

	bra	TS4078			| Avsluta rutinen


|--------------------------------------------------------------------------
| Anropas bara ifr}n _dbstrategy()
|
| a5	IO Req Block
| d6	Bit nr som kortets CSB signal kommer p}
| d7	Adress del av minor nummer
|

TS4066:
	movl	d7,d0			| Adress del av minor nummer
	asll	#8,d0			| * 256
	addl	d6,d0			| Maska in bit nr f|r CSB signal
	movl	d0,-(sp)		| Data f|r _dbintr()
	movl	#_dbintr,-(sp)		| Avbrottshanterare
	clrl	-(sp)			| 0

	moveq	#0x1,d0
	movl	d0,-(sp)		| 1
	movl	d7,d0			| Adress delen av minor nummer
	moveq	#0xb,d1
	asll	d1,d0			| Adress bitarna {r 01f800
	orl	#DBbaseadr,d0		| Maska in basadress
	movl	d0,-(sp)		| HW adress p} stacken
	jsr	_gdynvek		| Generera vektor nummer
	addql	#8,sp

	movl	d0,-(sp)		| Vektor nummer
	jsr	_setint			| 
	addw	#0x10,sp

	addql	#2,0x1e(a5)		| 
	movl	0x22(a5),d0
	subql	#2,d0
	movl	d0,0x66(a5)

	jsr	_spl3			| Hindra avbrott < niv} 3

	movl	d7,-(sp)		| Adress del av minor nummer
	pea	(a5)			| IO Req Block
	bsr	_dbproc
	addql	#8,sp

	tstl	d0
	bnes	TS4073

	movl	d6,d0
	asll	#2,d0
	addl	#_dbrnt,d0
	movl	d0,a0
	tstl	(a0)
	beqs	TS4075

TS4073:
	jsr	_spl0			| S{tt avbrottsniv} 0
	bra	TS4074

TS4075:
	movl	d6,d0
	asll	#2,d0
	addl	#_dbrnt,d0
	movl	d0,a0
	movl	a5,(a0)

	jsr	_spl0			| S{tt avbrottsniv} 0
	bra	TS4076


|--------------------------------------------------------------------------
| Anropas bara ifr}n _dbintr()
|
| a5	IO Req Block
| d6	Bit nr som kortets CSB signal kommer p}
| d7	Adress del av minor nummer
|

TS4077:
	movl	d7,-(sp)		| Adress del av minor nummer
	pea	(a5)			| IO Req Block
	bsr	_dbproc
	addql	#8,sp

	tstl	d0
	beqs	TS4078			| Avsluta rutinen

	movl	d6,d0
	asll	#2,d0
	addl	#_dbrnt,d0
	movl	d0,a0
	clrl	(a0)

	pea	(a5)
	jsr	_iodone
	addql	#4,sp

TS4078:
	moveml	(sp)+,#0x20c0	| d6 d7 a5
	unlk	a6
	rts


|-------------------------------------------------------------------------
| -dbcancel()
|
| Parametrar vid anrop (efter link a6..):
|	0x8(a6)		IO Req Block
|

	.globl	_dbcancel
_dbcancel:
	link	a6,#0x0
	moveml	#0x304,-(sp)		| d6 d7 a5

	movl	0x8(a6),a5		| IO Req Block

	jsr	_spl3			| S{tt avbrottsniv} 3
	movl	d0,d6			| Spara gammal niv}

	clrl	d7

TS4081:
	cmpl	#0x10,d7
	bges	TS4079			| Avsluta rutinen

	movl	d7,d0
	asll	#2,d0
	addl	#_dbrnt,d0
	movl	d0,a0
	movl	(a0),d0
	cmpl	a5,d0
	bne	TS4080

	movl	d7,d0
	asll	#2,d0
	addl	#_dbrnt,d0
	movl	d0,a0
	clrl	(a0)

	movw	#0xfffc,0x36(a5)

	bset	#2,0x6d(a5)

	pea	(a5)			| IO Req Block
	jsr	_iodone
	addql	#4,sp


	| ]terst{ll avbrottsniv}n och avsluta rutinen
TS4079:
	movl	d6,-(sp)
	jsr	_splx
	addql	#4,sp

	moveml	(sp)+,#0x20c0		| d6 d7 a5
	unlk	a6
	rts


|-------------------------------------------------------------------------
| _dbproc()
|
| Parametrar vid anrop (efter link a6..):
|	0x8(a6)		IO Req Block
|	0xc(a6)		Adress del av minor numer
|

_dbproc:
	link	a6,#0xfffc
	moveml	#0x70c,-(sp)		| d5 d6 d7 a4 a5

	movl	0x8(a6),a5		| IO Req Block
	movl	0xc(a6),d7		| Adress del av minor nummer

	movl	0x1e(a5),a4
	movl	0x66(a5),d6
	bnes	TS4067

TS4072:
	moveq	#0x1,d0

TS4071:
	moveml	(sp)+,#0x30e0		| d5 d6 d7 a4 a5
	unlk	a6
	rts


|-------------------------------------------------------------------------
| _copy_ms()
|
| Parametrar vid anrop (efter link a6..):
|	0x8(a6)		Fr}n
|	0xc(a6)		Till
|	0x10(a6)	Antal
|

_copy_ms:
	link	a6,#0x0
	moveml	#0xf0c,-(sp)		| d4 d5 d6 d7 a4 a5

	movl	0x8(a6),d7
	movl	0xc(a6),a5
	movl	0x10(a6),d6

	clrl	d0
	movw	XPAGEA,d0		| Mapper access
	movl	d0,d5

TS4065:
	tstl	d6			| Antal = 0 ?
	beq	TS4062			| Ja, avsluta rutinen

	movl	d7,d0
	andl	#0x7ff,d0
	addl	#XPAGE,d0
	movl	d0,a4
	movl	#YPAGE,d0
	subl	a4,d0
	movl	d0,d4
	cmpl	d6,d4
	bles	TS4063

	movl	d6,d4

TS4063:
	movl	d7,d0
	moveq	#0xb,d1
	asrl	d1,d0
	bset	#14,d0
	movw	d0,XPAGEA		| Mapper access
	subl	d4,d6
	addl	d4,d7

TS4064:
	movb	(a4)+,(a5)+
	subql	#1,d4
	bnes	TS4064
	bras	TS4065

TS4080:
	addql	#1,d7
	bra	TS4081


|-------------------------------------------------------------------------
|	a5	IO Req Block
|	d6	
| 	d7 	Adress del av minor nummer
|

TS4067:
	moveq	#0x2,d0
	movl	d0,-(sp)
	pea	0xfffe(a6)
	pea	(a4)
	bsrs	_copy_ms
	addw	#0xc,sp

	addql	#2,a4
	subql	#2,d6
	movb	0xffff(a6),d0
	extw	d0
	extl	d0
	movl	d0,d5
	movb	0xfffe(a6),d0
	extw	d0
	extl	d0
	subl	#0x8,d0
	cmpl	#0xd,d0
	bhi	TS4068

	addw	d0,d0
	movw	pc@(0x6,d0:w),d0
	jmp	pc@(0x2,d0:w)

	.word	0x8a
	.word	0x9e
	.word	0xb4
	.word	0xc8
	.word	0xc8
	.word	0xc8
	.word	0xc8
	.word	0xc8
	.word	0x26
	.word	0xc8
	.word	0x34
	.word	0x4e
	.word	0x62
	.word	0x76

	bra	TS4068

TS4070:
	clrl	d0
	bra	TS4071			| Avsluta rutinen


|--------------------------------------------------------------------------
| Skriv till data register OUT*
|

	| Ber{kna adressen till kortet
	movl	d7,d0
	moveq	#0xb,d1
	asll	d1,d0
	orl	#DBbaseadr,d0
	movl	d0,a0

	movb	d5,(a0)			| OUT*
	bra	TS4068


|--------------------------------------------------------------------------
| Skriv till kontroll register C1*
|

	| Ber{kna adressen till kortet
	movl	d7,d0
	moveq	#0xb,d1
	asll	d1,d0
	orl	#DBbaseadr,d0
	movl	d0,a0

	movb	d5,0x8(a0)		| C1*
	bras	TS4068


|--------------------------------------------------------------------------
| Skriv till kontroll register C2*
|

	| Ber{kna adressen till kortet
	movl	d7,d0
	moveq	#0xb,d1
	asll	d1,d0
	orl	#DBbaseadr,d0
	movl	d0,a0

	movb	d5,0xc(a0)		| C2*
	bras	TS4068


|--------------------------------------------------------------------------
| Skriv till kontroll register C3*
|

	| Ber{kna adressen till kortet
	movl	d7,d0
	moveq	#0xb,d1
	asll	d1,d0
	orl	#DBbaseadr,d0
	movl	d0,a0

	movb	d5,0x10(a0)		| C3*
	bras	TS4068


|--------------------------------------------------------------------------
| Skriv till kontroll register C4*
|

	| Ber{kna adressen till kortet
	movl	d7,d0
	moveq	#0xb,d1
	asll	d1,d0
	orl	#DBbaseadr,d0
	movl	d0,a0

	movb	d5,0x14(a0)		| C4*
	bras	TS4068


|--------------------------------------------------------------------------
| L{s av data register INP*
|

	| Ber{kna adressen till kortet
	movl	d7,d0
	moveq	#0xb,d1
	asll	d1,d0
	orl	#DBbaseadr,d0
	movl	d0,a0

	movb	(a0),0xfffd(a6)		| INP*
	bras	TS4068


|--------------------------------------------------------------------------
| L{s av status register STAT*
|

	| Ber{kna adressen till kortet
	movl	d7,d0
	moveq	#0xb,d1
	asll	d1,d0
	orl	#DBbaseadr,d0
	movl	d0,a0

	movb	0x4(a0),0xfffd(a6)	| STAT*
	bras	TS4068


|--------------------------------------------------------------------------
| L{s av status register OPS*
|

	| Ber{kna adressen till kortet
	movl	d7,d0
	moveq	#0xb,d1
	asll	d1,d0
	orl	#DBbaseadr,d0
	movl	d0,a0

	movb	0x8(a0),0xfffd(a6)	| OPS*


|--------------------------------------------------------------------------
|

TS4068:
	tstl	d6
	beqs	TS4069

	cmpb	#0xf,0xfffe(a6)
	bne	TS4067

TS4069:
	movl	a4,0x1e(a5)
	movl	d6,0x66(a5)
	cmpb	#0xf,0xfffe(a6)
	beq	TS4070
	bra	TS4072

TS4062:
	movl	d5,d0
	bset	#14,d0
	movw	d0,XPAGEA		| Mapper access

	moveml	(sp)+,#0x30f0		| d4 d5 d6 d7 a4 a5
	unlk	a6
	rts
