
| Utdrag ur dnix_start.s

PAGEMAP =	0x800080
CIOCTL	=	0x800107
SCSI_0	=	0xfd5000
SCSI_1	=	0xfd6000

|------------------------------------------------------------------------
| _setint()
|
|	8(a6)   Long	Entry nummer i _intport tabellen
|	c(a6)   Long	0 eller 1
|	10(a6)  Long	Avbrottshanterare
|	14(a6)  Long	Driver data (unik f|r varje driver)
|
| F|ljande parametrar anropas rutinen med:
|
|  GDV = resultat fr}n rutinen _gdynvek()
|
|  anrop fr}n	8(a6) 	      c(a6) 	10(a6)	    	14(a6)
|  ----------   -----         -----     ------      	------
|  _cioinit   	GDV		0
|	      	GDV + 3		1
|
|  mag_dev.s						0
|
|  si_dev.s	GDV		0	_siintr		Pekare till SCSI data
|
|  db_dev.s	GDV		0	_dbintr		Driver data
|
|  sio_dev.s  	GDV + 4		        _sioxint
|	 	GDV + 5	        	_siostint
|		GDV + 6	        	_siorint
|		GDV + 7	        	_siosrint
|

	.globl	_setint
_setint:
	link	a6,#0x0
	movl	d7,-(sp)

	subl	#0x20,0x8(a6)		| Vektor nummer i _intport tabellen

	| Stoppa alla avbrott < niv} 7
	jsr	_spl7
	movl	d0,d7			| Spara gammal avbrottsniv}

	movw	#0x4000,PAGEMAP		| 0x800080, Mappa in 0-7ff med R/W 

	| Ber{kna adress
	movl	0x8(a6),d0
	asll	#3,d0			| Entry nummer * 8
	addl	#0x400,d0		|  + basadress
	movl	d0,a0

	movl	0x10(a6),(a0)		| Avbrottshanterare

	| Ber{kna adress
	movl	0x8(a6),d0
	asll	#3,d0			| Entry nummer * 8
	addl	#0x404,d0		|  + basadress
	movl	d0,a0

	movl	0x14(a6),(a0)		| Driver data 

	clrw	PAGEMAP			| 0x800080, Tag bort skriv access

	| ]terst{ll gammal avbrottsniv}
	movl	d7,-(sp)
	jsr	_splx
	addql	#4,sp

	tstl	0xc(a6)			|
	beqs	TS1655

	moveq	#0x6,d0
	movl	d0,-(sp)
	jsr	_PANIC
	addql	#4,sp


	| Avsluta rutinen
TS1655:
	movl	(sp)+,d7
	unlk	a6
	rts


|------------------------------------------------------------------------
| _finvini()
|
| Initierar _intport tabellens entry 0..7.
|
| _intport:	0	fdb041
|		1	ffffffff
|		2	ffffffff
|		3	ffffffff
|		4	ffffffff
|		5	ffffffff
| BS1633:	6	fd6000
| BS1634:	7	fd5000
|		..	???
|
| BS1633 & BS1634 anv{nds bara h{r och i data-arean
|

	.globl	_finvini
_finvini:
	link	a6,#0x0
	movl	d7,-(sp)

	| Initiera entry 1..5 med 0xffffffff

	moveq	#0x1,d7			| B|rja med entry 1

TS1632:
	| Ber{kna adressen till entryt i tabellen
	movl	d7,d0
	asll	#2,d0
	addl	#_intport,d0
	movl	d0,a0

	movl	#0xffffffff,(a0)

	addql	#1,d7			| N{sta entry

	cmpl	#0x6,d7			| Klar ?
	blts	TS1632			| Nej, hoppa

	| Initiera entry 0, 6 och 7

	movl	#0xfdb041,_intport	| Entry 0, Floppy adress
	movl	#SCSI_1,BS1633		| Entry 6, SCSI-1 adress 0xfd6000
	movl	#SCSI_0,BS1634		| Entry 7, SCSI-0 adress 0xfd5000

	movl	(sp)+,d7
	unlk	a6
	rts


|------------------------------------------------------------------------
| _gdynvek()
|
| 	8(a6)	Long	HW adress
|	c(a6)	Long			Antal vektor som efterfr}gas och
|					skall placeras i f|ljd
|
| Anropas av:
|
|	db_dev.s	fexx01 - ffxx01		1
|	_cioinit	800107			4
|	fp_dev.s	fdb041			1
|	mag_dev.s	ff7001			4
|	n4_dev.s	fexx01 - ffxx01		1
|	si_dev.s	fd5000, fd6000		1
|	sp1_dev.s	fexx01 - ffxx01		1
|	ua_dev.s	fexx01 - ffxx01		1
|	wd_dev.s	fexx01 - ffxx01		1
|	sio_dev.s	fc00x5, fc00x1		8	x = 0..7
|
| Lokala variabler:
|
|	fff8(a6)
|	fffc(a6)
|

	.globl	_gdynvek
_gdynvek:
	link	a6,#0xfff8
	moveml	#0x1f00,-(sp)		| d3 d4 d5 d6 d7

	movl	0x8(a6),d7		| HW adress
	movl	0xc(a6),d6		| 1

	| Kontrollera om HW adress tillh|r 4680-bussen (Databoard).
	| Hoppa till TS1635 om inte.
	cmpl	#0xfe0001,d7
	bcss	TS1635
	cmpl	#0xfff801,d7
	bhis	TS1635

	| Ja, Adress tillh|r Databoard bussen
	movl	d7,a0
	movb	0x40(a0),d0		| L{s av CSB register
	notb	d0
	andl	#0xff,d0		| Maska fram CSB bitarna

	| Konvertera mask till bit nr. Returnerar -1 om ingen eller
	| flera bitar {r satta.
	movl	d0,-(sp)
	bsr	_masktobn		
	addql	#4,sp

	movl	d0,0xfff8(a6)		| Spara resultat
	bges	TS1646			| Avsluta med bitnr + 0x20 om OK
	bra	TS1639			| annars avsluta med -1

TS1638:
	movl	d5,d0

TS1646:
	addl	#0x20,d0
	bras	TS1639			| Avsluta rutinen


	| Kontrollera om HW adressen finns i tabellen
TS1635:
	movl	d7,d7
	clrl	d5
	bras	TS1636

TS1637:
	movl	d5,d0
	lsll	#2,d0
	addl	#_intport,d0
	movl	d0,a0
	movl	(a0),d0
	cmpl	d7,d0
	beqs	TS1638			| Ja, HW adressen finns i tabellen
					| d5 inneh}ller entry nr i tabellen
	addl	d6,d5

TS1636:
	cmpl	_antvect,d5		| Har hela tabellen kontrollerats ?
	bcss	TS1637			| Nej, hoppa

	| HW adressen fanns inte i tabellen.
	movl	_antvect,d0		| 0xc0
	subl	d6,d0
	movl	d0,0xfffc(a6)
	clrl	d5
	bras	TS1640

TS1642:
	movl	d4,d0
	addql	#1,d4
	lsll	#2,d0
	addl	#_intport,d0
	movl	d0,a0
	tstl	(a0)
	beqs	TS1643

TS1640:
	cmpl	0xfffc(a6),d5	| hoppa om d5 > xx
	bhis	TS1641			| Skriv ut PANIC meddelande och
					| avsluta rutinen

	movl	d5,d4
	movl	d4,d3
	addl	d6,d5

TS1643:
	cmpl	d5,d4
	bcss	TS1642		| hoppa om d4 < d5

	movl	d3,d4
	bras	TS1644

TS1645:
	movl	d4,d0
	lsll	#2,d0
	addl	#_intport,d0
	movl	d0,a0
	movl	d7,(a0)
	addql	#1,d4

TS1644:
	cmpl	d5,d4
	bcss	TS1645		| hoppa om d4 < d5

	movl	d3,d0
	bras	TS1646


	| Skriv ut PANIC meddelande
TS1641:
	moveq	#0x6,d0
	movl	d0,-(sp)		| 6
	jsr	_PANIC
	addql	#4,sp

	clrl	d0			| Avsluta med v{rde 0

TS1639:
	moveml	(sp)+,#0xf8		| d3 d4 d5 d6 d7
	unlk	a6
	rts


|------------------------------------------------------------------------
| _clkstart()
|

	.globl	_clkstart
_clkstart:
	link	a6,#0x0

	movl	#0xc24,-(sp)	| 0xc  = Counter/Timer 3 Command/Status
				| 0x24 = Clear Interrupt Pending & 
				| 	 Interrupt under service,
				|	 Set Gate Command Bit,
				| 	 Clear Trigger Command Bit
	movl	#CIOCTL,-(sp)	| 0x800107,
	jsr	_out2b
	addql	#8,sp

	unlk	a6
	rts



