
|---------------------------------------------------------------------------
| SCSI driver
| -----------
|
| Minor nummer:
|
|	Bit 7 		0 --> H}rddisk
|			1 --> Streamer
|	Bit 6,5,4	SCSI port nr, 0xfd5000 = 0, 0xfd6000 = 1
|	Bit 3,2,1,0	Unit nr, d{r bit 0 = 0 -> Rewind, 1 --> No Rewind
|			
|---------------------------------------------------------------------------

| Anv{nda adresser:
|	0x3a8122	Skriv	N}gon typ av status/felkod
|				u_error : char
|				errorcode from some drivers
|	0xfd5000		si0 HW adress
|	0xfd6000		si1 HW adress
|	0x800107		CIO (Z8536A) register 3  (CIOCTL)

u_error =	0x3a8122
CIOCTL	=	0x800107
SCSI_0	=	0xfd5000
SCSI_1	=	0xfd6000

|---------------------------------------------------------------------------
| _siopen()
|
| Parametrar vid anrop (efter link a6..):
|	0xa(a6)		Word	minor nummer
|	0xb(a6)		Byte	Del av 0xa(a6)
|

	.globl	_siopen
_siopen:
	link	a6,#0x0
	moveml	#0x31c,-(sp)	| d6 d7 a3 a4 a5

	| Ber{kna adress till SCSI port data
	movl	#0x276,-(sp)    | l{ngd p} varje SCSI port data i _satab
	movw	0xa(a6),d0	| minor nummer
	extl	d0
	asrl	#4,d0
	andl	#0x7,d0		| maska fram SCSI port nr
	movl	d0,-(sp)
	jsr	lmul		| Ber{kna offset i _satab
	addql	#8,sp
	addl	#_satab,d0	| Adressen till SCSI port 0 data
	movl	d0,a5


	| a5 inneh}ller nu ber{knad adress. Pekar adressen i _satab ?
	cmpl	#_localnode,d0
	bccs	TS2881		| Nej, Avsluta med felkod -6


	| a5 inneh}ller nu adressen till SCSI port data
	| Ber{kna adressen till unit data
	lea	0x56(a5),a0	| adressen till unit 0 data
	movw	0xa(a6),d0	| minor nummer
	andl	#0xf,d0		| maska fram unit nummer 0..15
	asll	#5,d0		| 32 * unit nummer
	addl	d0,a0
	movl	a0,a4

	| a4 inneh}ller nu adressen till unit data

	btst	#4,0x1(a4) 	| Unit redan |ppen ?
	bnes	TS2883		| Ja, Avsluta rutinen ...

	tstl	0x42(a5)	| [r HW adress och avbrottshanterare fixad ?
	bnes	TS2884		| Ja,


	| Best{m HW adress och initiera HW och avbrottshanterare

	cmpl	#_satab,a5	| SCSI port 0 ?
	bnes	TS3043		| Nej,

	movl	#SCSI_0,d0	| Ja, 0xfd5000, SCSI port 0 dvs si0
	bras	TS3044

TS2883:
	btst	#7,0xb(a6)	| Streamer ?
	bnes	TS2881		| Ja, Avsluta rutinen med Felkod -6

	| Denna unit {r en h}rddisk
	btst	#2,0x1(a4)	| ??????
	beq	TS2882		| Avsluta rutinen


	| Avsluta rutinen med felkod -6
TS2881:
	movb	#0xfffa,u_error		| 0x3a8122, Felkod -6
	bra	TS2882			| Avsluta rutinen


TS3043:
	movl	#SCSI_1,d0	| 0xfd6000, SCSI port 1 dvs. si1


	| Initiera HW och avbrottshanterare
TS3044:
	movl	d0,0x42(a5)	| Spara HW adress i unit data

	pea	(a5)		| SCSI port data
	movl	#_siintr,-(sp)	| Avbrottshanterare
	clrl	-(sp)		| 0

	moveq	#0x1,d0
	movl	d0,-(sp)	| 1
	movl	0x42(a5),-(sp)	| HW adress p} stacken
	jsr	_gdynvek
	addql	#8,sp

	movl	d0,-(sp)	|
	jsr	_setint
	addw	#0x10,sp

	| Utf|r ??
	pea	(a5)		| SCSI port data
	bsr	_sireset
	addql	#4,sp


	| HW och avbrottshanterare ordnad
TS2884:
	btst	#7,0xb(a6)	| H}rddisk ?
	beqs	TS2885		| Ja, hoppa


	| Initiering f|r streamer
	orw	#0x6,(a4)
	clrl	0xe(a4)
	movl	#0x200,0x6(a4)	| Default Block storlek
	movl	#0x9,0x2(a4)	| Default n i uttrycket 2**n
	clrl	0xa(a4)

	| Test Unit Ready
	clrl	-(sp)		| 0 = Offset fr}n start
	clrl	-(sp)		| 0 = L{ngd
	clrl	-(sp) 		| 0 = Destination
	clrl	-(sp)		| 0 = Test Unit Ready kommando
	movw	0xa(a6),d0
	extl	d0
	movl	d0,-(sp)	| minor nummer
	bsr	_docmd
	addw	#0x14,sp

	movl	d0,d6		| status fr}n _docmd
	bges	TS3042		| Hoppa om kommandot gick bra

TS3036:
	movb	d6,u_error	| 0x3a8122, Spara status som Felkod
	bra	TS3037		| Avsluta ??


	| Mode select f|r streamer
	| _modesel inneh}ller 4 byte (komplettering av kommando):
	|	0x00	Skall vara 0
	| 	0x00	Skall vara 0
	|	0x10	Bit 4 = 1 --> 'Buffered mode of write operations'
	|	0x08	Skall vara 8

TS3042:
	clrl	-(sp)		| 0 = Offset fr}n start
	moveq	#0x4,d0
	movl	d0,-(sp)	| 4 = L{ngd
	movl	#_modesel,-(sp)	| K{lla, se ovan
	moveq	#0x15,d0
	movl	d0,-(sp)	| Mode select kommando
	movw	0xa(a6),d0
	extl	d0
	movl	d0,-(sp)	| Minor nummer
	bsr	_docmd
	addw	#0x14,sp

	movl	d0,d6		| Status fr}n _docmd
	blts	TS3036		| Avsluta om fel
	bra	TS3041		| Hoppa till avslutning av rutinen


	| H}rddisk kontroller initiering
TS2885:
	orw	#0x22,(a4)
	movl	#0x400,0x6(a4)		| Default storlek = 1 Kbyte
	movl	#0xa,0x2(a4)		| Default n i uttrycket 2**n
	movl	#0x2000,0xe(a4)

	| F|rs|k l{sa 1 Kbyte, f|r att best{mma blockstorlek
	clrl	-(sp)			| 0 = Offset fr}n start
	movl	#0x400,-(sp)		| 0x400 = L{ngd
	movl	#_localbuf,-(sp)	| Destination
	moveq	#0x8,d0
	movl	d0,-(sp)		| Read kommando
	movw	0xa(a6),d0
	extl	d0
	movl	d0,-(sp)		| Minor nummer
	bsr	_docmd
	addw	#0x14,sp

	movl	d0,0x6(a4)		| Spara status fr}n _docmd

	movl	d0,-(sp)		| Antal byte som verkligen l{sts
	bsr	_itobn			| Konvertera dessa till n i 2**n
	addql	#4,sp

	movl	d0,0x2(a4)		| Spara i unit data som blockstorlek
	bges	TS3035			| Hoppa om konverteringen gick bra.

	| Skriv ut felmeddelnde
	movw	0xa(a6),d0
	andl	#0xff,d0
	movl	d0,-(sp)		| minor nummer

	| "si%d:Can\'t findout block size."
	movl	#_modesel+4,-(sp)	| adress till felmeddelande
	clrl	-(sp)			| 0
	movl	#0x80,-(sp)		| 0x80
	jsr	_ERR_MESS
	addw	#0x10,sp

	movb	#0xfffb,u_error		| 0x3a8122, Felkod -5
	bra	TS3037			| Avsluta ??


	| L{s Init Record
TS3035:
	bclr	#5,0x1(a4)
	movl	#0x400,-(sp)		| 0x400 = Offset fr}n start
	movl	0x6(a4),-(sp)		| L{ngd
	movl	#_localbuf,-(sp)	| Destination
	moveq	#0x8,d0
	movl	d0,-(sp)		| Read kommando
	movw	0xa(a6),d0
	extl	d0
	movl	d0,-(sp)		| Minor nummer
	bsr	_docmd
	addw	#0x14,sp

	movl	d0,d6			| Status fr}n _docmd
	blt	TS3036			| Avsluta rutinen om fel


	| Kontrollera init record (512 bytes)
	| Alla bytes XOR med varandra och resultatet XOR med FF
	| skall ge resultatet 0 f|r att vara OK.

	moveq	#0xffffffff,d7
	movl	#_localbuf+512,a3
	movl	#0x200,d6
	bras	TS3038

TS3039:
	subql	#1,a3
	movb	(a3),d0
	eorb	d0,d7

TS3038:
	subql	#1,d6
	bges	TS3039
	tstb	d7
	beqs	TS3040


	| Init record {r felaktigt. Skriv ut felmeddelande

	movw	0xa(a6),d0
	andl	#0xff,d0
	movl	d0,-(sp)		| minor nummer p} stacken

	| "si%d:Bad init record."
	movl	#_modesel+35,-(sp)	| Adress till felmeddelande
	clrl	-(sp)			| 0
	moveq	#0x40,d0
	movl	d0,-(sp)		| 0x40
	jsr	_ERR_MESS
	addw	#0x10,sp

	movb	#0x1,0x1f(a4)
	bras	TS3041


	| Init record OK. H{mta parametrar
TS3040:
	lea	0x10(a3),a0		| Parametrar b|rjar 16 bytes in

	| Kopiera parametrar till unit data strukturen
	movl	0xa(a0),0x1c(a4)
	movl	0x6(a0),0x18(a4)
	movl	0x2(a0),0x14(a4)
	movw	(a0),0x12(a4)

	clrl	0xe(a4)

TS3041:
	bset	#4,0x1(a4)	| S{tt unit |ppnad

TS3037:
	bclr	#1,0x1(a4)

TS2882:
	moveml	(sp)+,#0x38c0	| d6 d7 a3 a4 a5
	unlk	a6
	rts


|----------------------------------------------------------------------
| _siclose()
|
| Parametrar vid anrop (efter link a6..):
|	0xa(a6)		Word	minor nummer
|	0xb(a6)		Byte	Del av 0xa(a6)
|	0xc(a6)		Long
|	0xf(a6)		Byte	Del av 0xc(a6)
|
| Minor nummer:
|	Bit 7 		0 --> H}rddisk
|			1 --> Streamer
|	Bit 6,5,4	SCSI port nr, 0xfd5000 = 0, 0xfd6000 = 1
|	Bit 3,2,1,0	Unit nr, d{r bit 0 = 0 -> Rewind, 1 --> No Rewind
|

	.globl	_siclose
_siclose:
	link	a6,#0x0
	moveml	#0xc,-(sp)	| a4 a5

	| Ber{kna adress till SCSI port data
	movl	#0x276,-(sp)	| L{ngd p} varje SCSI port data i _satab
	movw	0xa(a6),d0	| minor nummer
	extl	d0
	asrl	#4,d0
	andl	#0x7,d0		| maska fram SCSI port nr
	movl	d0,-(sp)
	jsr	lmul		| Ber{kna offset i _satab
	addql	#8,sp
	addl	#_satab,d0	| Adressen till SCSI port 0 data
	movl	d0,a5

	| a5 inneh}ller nu adressen till SCSI port data
	| Ber{kna adressen till unit data
	lea	0x56(a5),a0	| adressen till unit 0 data
	movw	0xa(a6),d0	| minor nummer
	andl	#0xf,d0		| maska fram nummer 0..15
	asll	#5,d0		| 32 * unit nummer
	addl	d0,a0
	movl	a0,a4

	| a4 inneh}ller nu adressen till unit data

	btst	#7,0xb(a6)	| H}rddisk ?
	beqs	TS3045		| Ja, hoppa


	| Hantera en streamer

	cmpl	#0x2,0xc(a6)
	beqs	TS3046		| Ja, Skriv 'File Marks' p} bandet

	btst	#1,0xf(a6)
	beqs	TS3049		| Hoppa till }terspolning av bandet

	btst	#3,0x1(a4)
	beqs	TS3049		| Hoppa till }terspolning av bandet


	| Skriv 'File Marks' till bandet
TS3046:
	clrl	-(sp)		| 0 = Offset fr}n start
	movw	0xa(a6),d0	| minor nummer
	extl	d0
	btst	#0,d0		| Bit 0 i minor nummer (Rewind/No Rewind)
	beqs	TS3047

	moveq	#0x1,d0		| Unit som har 'No Rewind', Ett 'File Mark'
	bras	TS3048

TS3047:
	moveq	#0x2,d0		| Unit som har 'Rewind', Tv} 'File Marks'

TS3048:
	movl	d0,-(sp)	| Antal 'File Marks'
	clrl	-(sp)		| 0 = Destination
	moveq	#0x10,d0
	movl	d0,-(sp)	| Write File Mark kommando
	movw	0xa(a6),d0
	extl	d0
	movl	d0,-(sp)	| Minor nummer
	bsr	_docmd
	addw	#0x14,sp


	| ]terspola bandet om detta {r en s}dan unit
TS3049:
	btst	#0,0xb(a6)	| Skall bandet }terspolas ?
	bnes	TS3045		| Nej, avsluta rutinen

	| ]terspola bandet
	clrl	-(sp)		| 0 = Offset fr}n start
	clrl	-(sp)		| 0 = L{ngd
	clrl	-(sp)		| 0 = Destination
	moveq	#0x1,d0
	movl	d0,-(sp)	| Rewind kommando
	movw	0xa(a6),d0
	extl	d0
	movl	d0,-(sp)	| Minor nummer
	bsr	_docmd
	addw	#0x14,sp


TS3045:
	clrw	(a4)		| Indikera unit st{ngd
	moveml	(sp)+,#0x3000	| a4 a5
	unlk	a6
	rts


|-------------------------------------------------------------------------
| _sistrategy()
|
| Parametrar vid anrop (efter link a6..):
|	0x8(a6)
|
| Minor nummer:
|	Bit 7 		0 --> H}rddisk
|			1 --> Streamer
|	Bit 6,5,4	SCSI port nr, 0xfd5000 = 0, 0xfd6000 = 1
|	Bit 3,2,1,0	Unit nr, d{r bit 0 = 0 -> Rewind, 1 --> No Rewind
|

	.globl	_sistrategy
_sistrategy:
	link	a6,#0xfffc
	moveml	#0x13c,-(sp)	| d7 a2 a3 a4 a5

	movl	0x8(a6),a5	| 
	movw	0x72(a5),d0	| minor nummer ?????
	andl	#0xff,d0
	movl	d0,d7

	| Ber{kna adress till SCSI port data
	movl	#0x276,-(sp)	| L{ngd p} varje SCSI port data i _satab
	movl	d7,d0		| minor nummer
	asrl	#4,d0
	andl	#0x7,d0		| maska fram SCSI port nummer
	movl	d0,-(sp)
	jsr	lmul		| Ber{kna offset i _satab
	addql	#8,sp
	addl	#_satab,d0	| Adressen till SCSI port 0 data
	movl	d0,a4

	| a4 inneh}ller nu adressen till SCSI port data
	| Ber{kna adressen till unit data
	lea	0x56(a4),a0	| Adressen till unit 0 data
	movl	d7,d0		| minor nummer
	andl	#0xf,d0		| maska fram unit nummer 0..15
	asll	#5,d0		| 32 * unit nummer
	addl	d0,a0
	movl	a0,a3

	| a3 inneh}ller nu adressen till unit data

	cmpl	#_localnode,a5
	beqs	TS2888

	movl	0x6(a3),d0
	subql	#1,d0
	movl	0x22(a5),d1
	andl	d0,d1
	bnes	TS3026

TS2888:
	btst	#0,0x21(a5)
	beqs	TS2889

TS3026:
	movw	#0xfffb,0x36(a5)
	bras	TS3025

TS2889:
	clrl	0x66(a5)
	tstl	0xe(a3)
	beq	TS2890

	movl	0x2e(a5),d0
	cmpl	0xe(a3),d0
	bcs	TS3022

	btst	#0,0x6d(a5)
	beqs	TS3023

	movl	0x22(a5),0x66(a5)
	bras	TS3024

TS3023:
	movw	#0xfffa,0x36(a5)

TS3025:
	bset	#2,0x6d(a5)

TS3024:
	pea	(a5)
	jsr	_iodone
	addql	#4,sp

TS2894:
	moveml	(sp)+,#0x3c80	| d7 a2 a3 a4 a5
	unlk	a6
	rts


|------------------------------------------------------------------------
| _sistart()
|
| Parametrar vid anrop (efter link a6...):
|	0x8(a6)
|

_sistart:
	link	a6,#0xfffc
	moveml	#0x3c,-(sp)	| a2 a3 a4 a5

	movl	0x8(a6),a5	|

TS3006:
	lea	0x1c(a5),a0
	movl	a0,0xfffc(a6)
	tstl	(a0)
	bne	TS2895

	lea	0x4(a5),a0
	movl	a0,0xfffc(a6)
	tstl	(a0)
	bne	TS2895

	lea	0x10(a5),a0
	movl	a0,0xfffc(a6)
	tstl	(a0)
	bne	TS2895

	clrw	0x34(a5)

TS3004:
	moveml	(sp)+,#0x3c00	| a2 a3 a4 a5
	unlk	a6
	rts


|-----------------------------------------------------------------------
| _sirestart()
|
| Parametrar vid anrop (efter link a6...):
|	0x8(a6)
|

_sirestart:
	link	a6,#0xffec
	moveml	#0x11c,-(sp)	| d7 a3 a4 a5

	movl	0x8(a6),a5	|
	movl	(a5),a4
	movl	0x52(a5),a3
	tstl	0x46(a5)
	bnes	TS2901

	moveq	#0x32,d0
	movl	d0,-(sp)
	pea	(a5)
	movl	#_sitout,-(sp)
	jsr	_timeout
	addw	#0xc,sp

TS2901:
	movl	#0x5,0x46(a5)
	movl	#_siintr,0x4a(a5)
	clrw	0xfff2(a6)
	clrl	0xfff4(a6)
	clrl	0xffee(a6)
	movw	0x34(a5),d0
	extl	d0
	cmpl	#0x1,d0
	beq	TS2902
	cmpl	#0x3,d0
	beq	TS3001
	bra	TS2989

TS2911:
	movl	0xfff8(a6),d0
	asrl	#8,d0
	movl	d0,0xfff8(a6)
	movb	0xfffb(a6),0x2b(a5)
	movl	0xfff8(a6),d0
	asrl	#8,d0
	movl	d0,0xfff8(a6)
	movb	0xfffb(a6),0x2a(a5)
	movl	0xfff4(a6),d0
	moveq	#0x10,d1
	asrl	d1,d0
	bra	TS2912

TS3022:
	movl	0x2e(a5),d0
	addl	0x22(a5),d0
	cmpl	0xe(a3),d0
	blss	TS2890
	movl	0xe(a3),d0
	subl	0x2e(a5),d0
	movl	0x22(a5),d1
	subl	d0,d1
	movl	d1,0x66(a5)
	subl	d1,0x22(a5)

TS2890:
	jsr	_spl3
	cmpl	#_localnode,a5
	beq	TS2891

	btst	#0,0x6d(a5)
	beqs	TS3011

	lea	0x4(a4),a0
	bras	TS3021

TS3011:
	lea	0x10(a4),a0

TS3021:
	movl	a0,0xfffc(a6)
	movl	a0,a2
	tstl	(a2)
	bnes	TS3012
	movl	a5,(a0)
	movl	0xfffc(a6),a0
	movl	a5,0x4(a0)
	movl	0xfffc(a6),a0
	movl	a5,0x8(a0)
	clrl	0x12(a5)
	bra	TS3018

TS3012:
	movl	0xfffc(a6),a0
	movl	0x4(a0),a0
	movl	0x2e(a5),d0
	cmpl	0x2e(a0),d0
	blts	TS3013
	movl	0xfffc(a6),a0
	movl	0x4(a0),d0
	addl	#0x12,d0
	movl	d0,a2

TS3015:
	tstl	(a2)
	bnes	TS3016
	movl	0xfffc(a6),a0
	movl	0x4(a0),a0
	movl	0x2e(a5),d0
	cmpl	0x2e(a0),d0
	blts	TS3019
	movl	0xfffc(a6),a0
	movl	a5,0x4(a0)

TS3019:
	movl	0xfffc(a6),a0
	movl	a5,0x8(a0)
	bras	TS3017

TS3013:
	movl	(a2),a0
	movl	0x2e(a5),d0
	cmpl	0x2e(a0),d0
	bges	TS3014
	movl	0xfffc(a6),a0
	movl	0x4(a0),d0

TS3020:
	addl	#0x12,d0
	movl	d0,a2

TS3014:
	tstl	(a2)
	beqs	TS3015
	movl	(a2),a0
	movl	0x2e(a5),d0
	cmpl	0x2e(a0),d0
	blts	TS3015
	movl	a0,d0
	bras	TS3020

TS3016:
	movl	0xfffc(a6),a0
	movl	0x4(a0),d0
	addl	#0x12,d0
	cmpl	d0,a2
	bnes	TS3017
	movl	0x4(a0),a0
	movl	0x2e(a5),d0
	cmpl	0x2e(a0),d0
	blts	TS3017
	movl	0xfffc(a6),a0
	movl	a5,0x4(a0)

TS3017:
	movl	(a2),0x12(a5)
	movl	a5,(a2)
	bras	TS3018

TS2891:
	tstl	0x1c(a4)
	bnes	TS2892
	movl	a5,0x1c(a4)
	bras	TS3010

TS2892:
	movl	0x24(a4),a0
	movl	a5,0x12(a0)

TS3010:
	movl	a5,0x20(a4)
	movl	a5,0x24(a4)

TS3018:
	tstw	0x34(a4)
	bnes	TS2893
	pea	(a4)
	bsr	_sistart
	addql	#4,sp

TS2893:
	jsr	_spl0
	bra	TS2894

TS2895:
	movl	0xfffc(a6),a0
	movl	(a0),(a5)
	movl	(a5),a3
	movw	0x72(a3),d0
	andl	#0xff,d0
	asrl	#4,d0
	andl	#0x7,d0
	movw	d0,0x4e(a5)
	movw	0x72(a3),d0
	andl	#0xf,d0
	movw	d0,0x50(a5)
	lea	0x56(a5),a0
	movw	0x50(a5),d0
	extl	d0
	asll	#5,d0
	addl	d0,a0
	movl	a0,a4
	movl	a4,0x52(a5)
	movl	0x2e(a3),0x2e(a5)
	lea	0x1c(a5),a0
	movl	0xfffc(a6),d0
	cmpl	a0,d0
	beqs	TS2896
	btst	#3,0x6c(a3)
	bnes	TS3008
	bras	TS2896

TS3009:
	btst	#3,0x6c(a2)
	beqs	TS2896
	movw	0x72(a3),d0
	cmpw	0x72(a2),d0
	bnes	TS2896
	movl	0x2e(a3),d0
	addl	0x22(a3),d0
	cmpl	0x2e(a2),d0
	bnes	TS2896
	movl	a2,a3

TS3008:
	movl	0x12(a3),a2
	movl	a2,d0
	bnes	TS3009

TS2896:
	movl	0xfffc(a6),a0
	cmpl	0x4(a0),a3
	bnes	TS2897
	movl	a0,a1
	movl	0x8(a0),0x4(a1)

TS2897:
	movl	0xfffc(a6),a0
	movl	0x12(a3),(a0)
	clrl	0x12(a3)
	movl	(a5),a3
	btst	#2,0x1(a4)
	beqs	TS2898
	cmpl	#0xffffffff,0xa(a4)
	bnes	TS2898

TS3007:
	movl	a3,d0
	beq	TS3006
	bset	#2,0x6d(a3)
	movw	#0xfffb,0x36(a3)
	pea	(a3)
	jsr	_iodone
	addql	#4,sp
	movl	0x12(a3),a3
	bras	TS3007

TS2898:
	cmpl	#_localnode,a3
	bnes	TS2899
	movb	0x6b(a3),0x32(a5)
	bras	TS3005

TS2899:
	btst	#0,0x6d(a3)
	beqs	TS2900
	movb	#0x8,0x32(a5)
	bras	TS3005

TS2900:
	movb	#0xa,0x32(a5)

TS3005:
	movw	#0x1,0x34(a5)
	pea	(a5)
	bsr	_sirestart
	addql	#4,sp
	bra	TS3004

TS3001:
	movb	#0x3,0x28(a5)
	movw	(a3),d0
	extl	d0
	btst	#2,d0
	beqs	TS3002
	moveq	#0x8,d0
	bras	TS3003

TS3002:
	moveq	#0x4,d0

TS3003:
	movl	d0,0xfffc(a6)
	movl	d0,0xfff8(a6)
	lea	0x25e(a5),a0
	movl	a0,0xffee(a6)
	bra	TS2989

TS2902:
	movb	0x32(a5),0x28(a5)
	movb	0x28(a5),d0
	extw	d0
	extl	d0
	cmpl	#0x8,d0
	beqs	TS2903
	bgt	TS2995
	tstl	d0
	beq	TS2999
	cmpl	#0x1,d0
	beq	TS3000
	bra	TS2998

TS2996:
	movw	#0xffff,0xfff2(a6)

TS2903:
	movl	0x2e(a5),d0
	movl	0x2(a3),d1
	lsrl	d1,d0
	movl	d0,0xfff4(a6)
	movl	0x22(a4),0xfffc(a6)
	btst	#3,0x6c(a4)
	bnes	TS2904
	cmpl	#0x7800,0xfffc(a6)
	bles	TS2906
	movl	#0x7800,0xfffc(a6)

TS2906:
	movl	0xfffc(a6),d0
	movl	0x2(a3),d1
	asrl	d1,d0
	movl	d0,0xfff8(a6)
	btst	#2,0x1(a3)
	beq	TS2907
	movl	#0x78,0x46(a5)
	movl	0xfff4(a6),d0
	cmpl	0xa(a3),d0
	beqs	TS2991
	movw	#0x6,0x34(a5)
	movb	#0x11,0x28(a5)
	movl	0xfff4(a6),d0
	subl	0xa(a3),d0
	movl	d0,0xfff8(a6)
	cmpl	#0xffffff80,d0
	bges	TS2993
	movl	#0xffffff80,0xfff8(a6)
	bras	TS2994

TS2905:
	movl	0x22(a4),d0
	addl	d0,0xfffc(a6)

TS2904:
	movl	0x12(a4),a4
	movl	a4,d0
	bnes	TS2905
	movl	(a5),a4
	bras	TS2906

TS2993:
	cmpl	#0x400,0xfff8(a6)
	bles	TS2994
	movl	#0x400,0xfff8(a6)

TS2994:
	clrl	0xfffc(a6)

TS2990:
	clrl	0xfff4(a6)
	bra	TS2989

TS2991:
	cmpl	#0xffff,0xfff8(a6)
	bles	TS2992
	movl	#0xffff,0xfff8(a6)
	movl	0xfff8(a6),d0
	movl	0x2(a3),d1
	asll	d1,d0
	movl	d0,0xfffc(a6)

TS2992:
	movl	#0x10000,0xfff4(a6)
	bras	TS2909

TS2907:
	movw	(a3),d0
	andw	#0x23,d0
	bnes	TS2908
	btst	#0,0x1f(a3)
	bnes	TS2908
	movw	#0x2,0x34(a5)
	movb	#0xc,0x28(a5)
	movl	#0x8,0xfffc(a6)
	movl	0xfffc(a6),0xfff8(a6)
	lea	0x12(a3),a0
	movl	a0,0xffee(a6)
	movw	#0xffff,0xfff2(a6)
	bras	TS2990

TS2908:
	cmpl	#0xff,0xfff8(a6)
	bles	TS2909
	movl	#0xff,0xfff8(a6)
	movl	0xfff8(a6),d0
	movl	0x2(a3),d1
	asll	d1,d0
	movl	d0,0xfffc(a6)

TS2909:
	btst	#3,0x6c(a4)
	beqs	TS2910
	movl	0x42(a5),-(sp)
	pea	(a4)
	jsr	_dmachain
	addql	#8,sp
	movl	d0,0xffee(a6)
	bras	TS2989

TS3000:
	movl	#0xf0,0x46(a5)
	movw	#0x4,0x34(a5)
	clrl	0xfffc(a6)
	movl	0xfffc(a6),0xfff8(a6)
	bras	TS2989

TS2999:
	movl	#0x14,0x46(a5)
	bras	TS2998

TS2997:
	movl	#0x78,0x46(a5)
	bras	TS2998

TS2995:
	cmpl	#0xa,d0
	beq	TS2996
	cmpl	#0x10,d0
	beqs	TS2997
	cmpl	#0x15,d0
	bnes	TS2998
	movw	#0xffff,0xfff2(a6)

TS2998:
	movw	#0x5,0x34(a5)
	movl	0x22(a4),0xfffc(a6)
	movl	0xfffc(a6),0xfff8(a6)

TS2910:
	movl	0x1e(a4),0xffee(a6)

TS2989:
	movl	0xfff8(a6),0x3e(a5)
	movb	0xfffb(a6),0x2c(a5)
	btst	#2,0x1(a3)
	bne	TS2911
	movb	0xfff7(a6),0x2b(a5)
	movl	0xfff4(a6),d0
	asrl	#8,d0
	movl	d0,0xfff4(a6)
	movb	0xfff7(a6),0x2a(a5)
	movl	0xfff4(a6),d0
	asrl	#8,d0
	movl	d0,0xfff4(a6)
	movw	0x50(a5),d0
	andl	#0x1,d0
	asll	#4,d0
	orl	0xfff4(a6),d0

TS2912:
	movb	d0,0x29(a5)
	movb	0x1a(a3),0x2d(a5)
	movl	0xfffc(a6),-(sp)
	movl	0xffee(a6),-(sp)
	pea	0x28(a5)
	movw	0xfff2(a6),d0
	extl	d0
	movl	d0,-(sp)
	pea	(a5)
	pea	(a4)
	bsr	_sicmd
	addw	#0x18,sp
	tstl	d0
	bge	TS2942
	pea	(a5)
	bsrs	_siintr

TS2943:
	addql	#4,sp
	moveml	(sp)+,#0x3880	| d7 a3 a4 a5
	unlk	a6
	rts


|-----------------------------------------------------------------------
| _sitout()
|
| Parametrar vid anrop (efter link a6...):
|	0x8(a6)
|

_sitout:
	link	a6,#0x0
	moveml	#0x4,-(sp)	| a5

	movl	0x8(a6),a5	|
	tstw	0x34(a5)
	beqs	TS3050

	tstl	0x46(a5)
	beqs	TS3051

	subql	#1,0x46(a5)
	bne	TS3052
	pea	(a5)
	movl	0x4a(a5),a0
	jsr	(a0)
	addql	#4,sp
	bras	TS3051

TS3050:
	clrl	0x46(a5)

TS3051:
	movl	(sp)+,a5
	unlk	a6
	rts


|-----------------------------------------------------------------------
| _siintr()
|
| Parametrar vid anrop (efter link a6...):
|	0x8(a6)
|

_siintr:
	link	a6,#0x0
	moveml	#0x71c,-(sp)		| d5 d6 d7 a3 a4 a5

	movl	0x8(a6),a5		| SCSI port data
	movl	(a5),a4
	movl	0x52(a5),a3
	jsr	_spl7			| S{tt avbrottsniv} 7
	movl	d0,d5			| Spara gammal avbrottsniv}

	| Maska bort SCSI avbrott
	| Ber{kna f|rst masken
	movb	#0x27,CIOCTL		| 0x800107, 0x27 = Port A Mask Reg
	movw	0x4e(a5),d0
	extl	d0
	movl	#0x80,d1
	asrl	d0,d1
	notl	d1
	clrl	d0
	movb	CIOCTL,d0		| 0x800107, L{s av g{llande mask
	andl	d1,d0			| Maska bort SCSI bit
	orl	#0x2700,d0		| 0x27 = Port A Mask Reg

	| Skriv nu masken till CIO-kretsen
	movl	d0,-(sp)
	movl	#CIOCTL,-(sp)		| 0x800107,
	jsr	_out2b
	addql	#8,sp

	movl	d5,-(sp)		| Gammal avbrottsniv}
	jsr	_splx			| ]terst{ll avbrottsniv}n
	addql	#4,sp

	pea	(a5)			|
	bsr	_siclean
	addql	#4,sp

	movl	d0,d7
	cmpl	#0xffffffff,d0
	bne	TS2961

	tstl	0x46(a5)
	beq	TS2961

	movw	#0x1,0x34(a5)
	movl	#0x2,0x46(a5)
	movl	#_sirestart,0x4a(a5)

TS2973:
	moveml	(sp)+,#0x38e0	| d5 d6 d7 a3 a4 a5
	unlk	a6
	rts


|------------------------------------------------------------------------
| _sireset()
|
| Parametrar vid anrop (efter link a6...):
|	0x8(a6)
|


_sireset:
	link	a6,#0x0
	moveml	#0x10c,-(sp)		| d7 a4 a5

	movl	0x8(a6),a5		| H{mta adressen till SCSI port data
	jsr	_spl3			| S{tt avbrottsniv} 3
	movl	d0,d7			| Spara gammal avbrottsniv}

	movl	0x42(a5),a0		| H{mta HW adress till SCSI port
	clrw	0x80(a0)		| SCSI-CTRL, S{nd SCSIRST

	lea	0x56(a5),a0		| Basadress till unit data
	movl	a0,a4

	| Nollst{ll bit 0 i status i unit data f|r alla units
TS2976:
	lea	0x256(a5),a0		| Stopp villkor
	cmpl	a0,a4
	bcc	TS2975			| Om alla units genomg}gna

	bclr	#0,0x1(a4)
	addw	#0x20,a4		| N{sta unit
	bras	TS2976


TS2942:
	jsr	_spl7			| S{tt avbrottsniv} 7
	movl	d0,d7			| Spara gammal avbrottsniv}

	| Till}t SCSI avbrott i CIO-kretsen
	| Ber{kna f|rst masken
	movb	#0x27,CIOCTL		| 0x800107, 0x27 = Port A Mask Reg
	movw	0x4e(a5),d0
	extl	d0
	movl	#0x80,d1
	asrl	d0,d1
	clrl	d0
	movb	CIOCTL,d0		| 0x800107, L{s g{llande mask
	orl	d1,d0			| S{tt SCSI bit
	orl	#0x2700,d0		| 0x27 = Port A Mask Reg

	| Skriv ny mask till CIO-kretsen
	movl	d0,-(sp)
	movl	#CIOCTL,-(sp)		| 0x800107,
	jsr	_out2b
	addql	#8,sp

	movl	d7,-(sp)		| Gammal avbrottsniv}
	jsr	_splx			| ]terst{ll avbrottsniv}n
	bra	TS2943


TS3052:
	moveq	#0x32,d0
	movl	d0,-(sp)		| 0x32
	pea	(a5)			|
	movl	#_sitout,-(sp)		|
	jsr	_timeout
	addw	#0xc,sp

	bra	TS3051

TS2961:
	btst	#0,d7
	bnes	TS2962
	tstl	0x46(a5)
	bne	TS2979

TS2962:
	movb	0x28(a5),0x33(a5)
	tstl	0x46(a5)
	beqs	TS2963
	cmpw	#0x3,0x34(a5)
	beqs	TS2963
	movw	0x34(a5),d0
	extl	d0
	movl	d0,0x272(a5)
	movl	d7,d0
	bclr	#0,d0
	movl	d0,0x26e(a5)
	movw	#0x3,0x34(a5)
	bra	TS2974

TS2963:
	movl	0x2e(a5),d0
	movl	0x2(a3),d1
	lsrl	d1,d0
	movl	d0,0x38(a5)
	moveq	#0x3f,d6
	bra	TS2964
	movw	0x274(a5),0x34(a5)
	movl	0x26e(a5),d7
	btst	#2,0x1(a3)
	beq	TS4394
	movl	0x2e(a5),d0
	movl	0x2(a3),d1
	lsrl	d1,d0
	movl	d0,0x38(a5)
	clrl	d0
	movb	0x260(a5),d0
	movl	d0,d6
	movl	d6,d0
	andl	#0xf,d0
	cmpl	#0x7,d0
	bhi	TS2964
	addw	d0,d0
	movw	pc@(0x6,d0:w),d0
	jmp	pc@(0x2,d0:w)

	.word	0x10a
	.word	0x13a
	.word	0xf2
	.word	0xf2
	.word	0xf2
	.word	0xf2
	.word	0x14
	.word	0x7e

	bra	TS2964
	btst	#1,0x1(a3)
	beqs	TS4395

TS4400:
	movw	#0x1,0x34(a5)
	bra	TS2974

TS4395:
	movl	#0xffffffff,0xa(a3)

TS2965:
	cmpw	#0x1,0x34(a5)
	bne	TS2966
	btst	#2,0x1(a3)
	bne	TS2966
	addqw	#1,0x36(a5)
	cmpw	#0x5,0x36(a5)
	bgt	TS2966
	moveq	#0x3,d0
	movl	d0,-(sp)
	movw	0x36(a5),d0
	extl	d0
	movl	d0,-(sp)
	jsr	lrem
	addql	#8,sp
	tstl	d0
	beqs	TS2977
	tstl	0x46(a5)
	bnes	TS2978

TS2977:
	pea	(a5)
	bsr	_sireset
	addql	#4,sp

TS2978:
	movw	d6,0x3c(a5)
	bra	TS2974
	movw	#0xffe2,0x36(a4)
	bras	TS2965

TS4394:
	clrl	d0
	movb	0x25e(a5),d0
	movl	d0,d6
	btst	#7,0x25e(a5)
	beqs	TS4396
	clrl	d0
	movb	0x25f(a5),d0
	andl	#0xf,d0
	movl	d0,0x38(a5)
	lsll	#8,d0
	movl	d0,0x38(a5)
	clrl	d0
	movb	0x260(a5),d0
	orl	d0,0x38(a5)
	movl	0x38(a5),d0
	lsll	#8,d0
	movl	d0,0x38(a5)
	clrl	d0
	movb	0x261(a5),d0
	orl	d0,0x38(a5)
	bras	TS4397

TS4396:
	movl	0x2e(a5),d0
	movl	0x2(a3),d1
	lsrl	d1,d0
	movl	d0,0x38(a5)

TS4397:
	movl	d6,d0
	andl	#0x3f,d0
	cmpl	#0x18,d0
	beqs	TS4398
	cmpl	#0x21,d0
	beqs	TS4399

TS2964:
	cmpw	#0x1,0x34(a5)
	bne	TS2965
	movl	0x6(a3),d0
	negl	d0
	andl	d0,d7
	beq	TS2965

TS2979:
	clrl	d6

TS4399:
	movw	0x34(a5),d0
	extl	d0
	subl	#0x1,d0
	cmpl	#0x5,d0
	bhi	TS2973
	addw	d0,d0
	movw	pc@(0x6,d0:w),d0
	jmp	pc@(0x2,d0:w)

	.word	0x84
	.word	0x176
	.word	0xfe90
	.word	0x184
	.word	0x14a
	.word	0x78

	bra	TS2973

TS4398:
	movl	d6,-(sp)
	clrl	d0
	movb	0x33(a5),d0
	movl	d0,-(sp)
	movl	0x6(a3),-(sp)
	movl	0x38(a5),-(sp)
	movw	0x72(a4),d0
	extl	d0
	movl	d0,-(sp)
	moveq	#0x1,d0
	movl	d0,-(sp)
	jsr	_blkerror
	addw	#0x18,sp
	bras	TS2979

TS2966:
	tstl	0x46(a5)
	bnes	TS2967
	pea	(a5)
	bsr	_sireset
	addql	#4,sp

TS2967:
	movl	d6,-(sp)
	clrl	d0
	movb	0x33(a5),d0
	movl	d0,-(sp)
	movl	0x6(a3),-(sp)
	movl	0x38(a5),-(sp)
	movw	0x72(a4),d0
	extl	d0
	movl	d0,-(sp)
	clrl	-(sp)
	jsr	_blkerror
	addw	#0x18,sp
	bset	#2,0x6d(a4)
	bra	TS2970
	movl	0x3e(a5),d0
	addl	d0,0xa(a3)
	bra	TS4400
	btst	#0,0x6d(a4)
	bnes	TS4401
	bset	#3,0x1(a3)

TS4401:
	btst	#2,0x1(a3)
	beqs	TS4402
	movl	d6,d0
	andl	#0x90,d0
	beqs	TS4403
	addql	#1,0xa(a3)

TS4403:
	movl	d7,d0
	movl	0x2(a3),d1
	lsrl	d1,d0
	addl	d0,0xa(a3)

TS4402:
	tstw	0x36(a5)
	beqs	TS4404
	movw	0x3c(a5),d0
	extl	d0
	movl	d0,-(sp)
	clrl	d0
	movb	0x33(a5),d0
	movl	d0,-(sp)
	movl	0x6(a3),-(sp)
	movl	0x38(a5),-(sp)
	movw	0x72(a4),d0
	extl	d0
	movl	d0,-(sp)
	movw	0x36(a5),d0
	extl	d0
	movl	d0,-(sp)
	jsr	_blkerror
	addw	#0x18,sp
	clrw	0x36(a5)
	bras	TS4404

TS4406:
	subl	0x22(a4),d7
	movl	0x12(a4),(a5)
	pea	(a4)
	jsr	_iodone
	addql	#4,sp
	movl	(a5),a4
	movl	a4,d0
	beqs	TS4405
	movl	0x2e(a4),0x2e(a5)

TS4404:
	movl	0x22(a4),d0
	cmpl	d7,d0
	blss	TS4406

TS4405:
	movl	a4,d0
	beqs	TS2971
	tstl	d6
	bnes	TS4407
	btst	#5,0x1(a3)
	bnes	TS4407
	addl	d7,0x2e(a5)
	addl	d7,0x1e(a4)
	subl	d7,0x22(a4)

TS2974:
	pea	(a5)
	bsr	_sirestart

TS2972:
	addql	#4,sp
	bra	TS2973

TS4407:
	movl	0x22(a4),d0
	subl	d7,d0
	addl	d0,0x66(a4)

TS2970:
	clrw	0x36(a5)
	movl	0x12(a4),(a5)
	pea	(a4)
	jsr	_iodone
	addql	#4,sp
	movl	(a5),a4
	movl	a4,d0
	beqs	TS2971
	movl	0x2e(a4),0x2e(a5)
	bras	TS2974

TS2971:
	clrw	0x34(a5)
	pea	(a5)
	bsr	_sistart
	bras	TS2972
	movw	#0x1,0x34(a5)
	bset	#0,0x1(a3)
	bras	TS2974
	clrl	0xa(a3)
	bras	TS2970


TS2975:
	movl	0x42(a5),a0		| H{mta HW adress till SCSI port
	movw	#0x200,0x80(a0)		|

	| ]terst{ll gammal avbrottsniv}
	movl	d7,-(sp)
	jsr	_splx
	addql	#4,sp

	moveml	(sp)+,#0x3080		| d7 a4 a5
	unlk	a6
	rts


|-------------------------------------------------------------------------
| _sicmd()
|
| Parametrar vid anrop (efter link a6...):
|	0xc(a6)
|


	.globl	_sicmd
_sicmd:
	link	a6,#0x0
	moveml	#0x31c,-(sp)	| d6 d7 a3 a4 a5

	movl	0xc(a6),a5	| Adress till SCSI port data

	movl	0x42(a5),a4	| H{mta adress till HW SCSI port
	movw	0x50(a5),d0
	extl	d0
	asrl	#1,d0
	moveq	#0x1,d1
	asll	d0,d1		| Best{m Unit nummer f|r SCSI bussen
	bset	#9,d1		| Bit SCSIRST
	movw	d1,d6
	movw	d6,0x80(a4)	| SCSI-CTRL,

	movl	#0x2710,d7

TS2941:
	btst	#6,0x80(a4)	| SCSI-STAT, Bit SCSIBSY
	bnes	TS2913
	subql	#1,d7
	bnes	TS2941

TS2913:
	moveq	#0x20,d7
	tstl	0x10(a6)
	beqs	TS2914

	movl	0x1c(a6),d0
	cmpl	d7,d0
	bges	TS2914

	movl	0x18(a6),d0
	addl	0x1c(a6),d0
	movl	d0,a3
	bras	TS2939

TS2940:
	subql	#2,d7
	subql	#2,a3
	movl	a4,d0
	addl	d7,d0
	movl	d0,a0
	movw	(a3),(a0)

TS2939:
	cmpl	0x18(a6),a3
	bnes	TS2940
	clrl	0x1c(a6)

TS2914:
	movl	0x14(a6),d0
	addql	#6,d0
	movl	d0,a3
	bras	TS2915

TS2916:
	subql	#2,d7
	subql	#2,a3
	movl	a4,d0
	addl	d7,d0
	movl	d0,a0
	movw	(a3),(a0)

TS2915:
	cmpl	0x14(a6),a3
	bnes	TS2916
	pea	(a4)
	movl	0x10(a6),-(sp)
	movl	0x1c(a6),d0
	andl	#0xffffffe0,d0
	movl	d0,-(sp)
	movl	0x18(a6),-(sp)
	movl	0x8(a6),-(sp)
	jsr	_setdma
	addw	#0x14,sp

	tstl	d0
	beqs	TS2937
	movl	#0xffffffff,0x25a(a5)
	moveq	#0xffffffff,d0
	bras	TS2938

TS2937:
	movw	d6,d0
	extl	d0
	bset	#8,d0
	movl	a4,d1
	addl	d7,d1
	movl	d1,a0
	movw	d0,0x80(a0)
	movl	0x18(a6),0x256(a5)
	movl	0x1c(a6),d0
	andl	#0x1f,d0
	movl	d0,0x25a(a5)
	clrl	d0

TS2938:
	moveml	(sp)+,#0x38c0	| d6 d7 a3 a4 a5
	unlk	a6
	rts


|----------------------------------------------------------------------
| _siclean()
|
| Parametrar vid anrop (efter link a6...):
|	0x8(a6)
|

	.globl	_siclean

_siclean:
	link	a6,#0x0
	moveml	#0x31c,-(sp)	| d6 d7 a3 a4 a5

	movl	0x8(a6),a5	| SCSI port data
	movl	0x42(a5),a4	| H{mta HW adress SCSI port
	btst	#7,0x80(a4)	| SCSI-STAT, Bit SCSIINT
	bnes	TS2944

	moveq	#0xffffffff,d7
	bras	TS2960

TS2944:
	movw	0x80(a4),d0	| SCSI-STAT, 
	andl	#0x1f,d0	| Maska fram SCSI A3-A1 och ??
	movl	d0,d7

TS2960:
	movw	0x50(a5),d0
	extl	d0
	asrl	#1,d0
	moveq	#0x1,d1
	asll	d0,d1
	bset	#9,d1		| Bit SCSIRST
	movw	d1,0x80(a4)	| SCSI-CTRL, 
	tstl	0x25a(a5)
	bges	TS2945
	moveq	#0x1,d0
	bra	TS2956


|-----------------------------------------------------------------------
| Anropas bara fr}n rutinen _docmd()

TS2886:
	bset	#6,0x6d(a5)
	moveq	#0x1,d0
	movl	d0,-(sp)		| 1
	movl	#_genslpq,-(sp)		|
	jsr	_sleep
	addql	#8,sp

	bra	TS2887			| Hoppa in i rutinen _docmd()


TS2945:
	pea	(a4)			|
	jsr	_clrdma
	addql	#4,sp

	movl	d0,d6
	tstl	d7
	blts	TS2953
	movl	d7,d0
	subql	#2,d0
	movl	0x25a(a5),d1
	cmpl	d0,d1
	blts	TS2953
	movl	d7,d0
	subql	#2,d0
	movl	d0,0x25a(a5)
	movl	0x256(a5),d0
	addl	d6,d0
	movl	d0,a3
	clrl	d7
	bras	TS2957

TS2958:
	movl	a4,d0
	addl	d7,d0
	movl	d0,a0
	movw	(a0),(a3)+
	addql	#2,d7

TS2957:
	cmpl	0x25a(a5),d7
	blts	TS2958
	addl	d7,d6
	movl	a4,d0
	addl	d7,d0
	movl	d0,a0
	movw	(a0),d0
	extl	d0
	movl	d0,d7
	bras	TS2959

TS2953:
	movl	#0x200,d7
	clrl	d6

TS2959:
	btst	#11,d7
	beqs	TS2954

	moveq	#0xffffffff,d0		| Felkod = -1
	bras	TS2956			| Avsluta rutinen

TS2954:
	btst	#9,d7
	beqs	TS2955
	movl	d6,d0
	bset	#0,d0
	bras	TS2956

TS2955:
	movl	d6,d0

TS2956:
	moveml	(sp)+,#0x38c0		| d6 d7 a3 a4 a5
	unlk	a6
	rts


|------------------------------------------------------------------------
| _docmd()
|
| Parametrar vid anrop (efter link a6...):
|	0xa(a6)	   W	Minor nummer
|	0xe(a6)    W	Kommando
|	0x10(a6)   L	Destination/K{lla
|	0x14(a6)   L	L{ngd (bytes)
|	0x18(a6)   L	Offset fr}n start (bytes)
|

_docmd:
	link	a6,#0x0
	moveml	#0x104,-(sp)		| d7 a5

	movl	#_localnode,a5

	| a5	adressen till unit data ?????

TS2887:
	btst	#3,0x6d(a5)
	bne	TS2886

	pea	(a5)			|
	jsr	_ioinirn
	addql	#4,sp

	movw	#0x9,0x6c(a5)
	movw	0xa(a6),0x72(a5)
	movw	0xe(a6),0x6a(a5)
	movl	0x14(a6),0x22(a5)
	movl	0x18(a6),0x2e(a5)
	movl	0x10(a6),0x1e(a5)

	pea	(a5)			|
	bsr	_sistrategy
	addql	#4,sp

	pea	(a5)			|
	jsr	_waitrq
	addql	#4,sp

	btst	#6,0x6d(a5)
	beqs	TS3027

	movl	#_genslpq,-(sp)		|
	jsr	_wakeup
	addql	#4,sp

TS3027:
	btst	#2,0x6d(a5)
	beqs	TS3028
	movw	0x36(a5),d0
	extl	d0
	bras	TS3029

TS3028:
	movl	0x22(a5),d0
	subl	0x66(a5),d0

TS3029:
	movl	d0,d7
	clrw	0x6c(a5)
	movl	d7,d0

	moveml	(sp)+,#0x2080		| d7 a5
	unlk	a6
	rts


|------------------------------------------------------------------------
| int _itobn (int : tal);
|
| Ber{knar n i uttrycket:  tal = 2 ** n
|
| Returnerar: -1 om tal {r felaktigt p} n}got s{tt
|   annars    exponenten n
|

_itobn:
	link	a6,#0x0
	moveml	#0x300,-(sp)		| d6 d7

	movl	0x8(a6),d7		| H{mta inparameter: tal
	beqs	TS3030			| Avsluta med fel -1 om tal == 0

	| Kontrollera att tal bara har en bit satt dvs n}got 
	| av talen 1, 2, 4, 8, 16, 32, 64, ...
	movl	d7,d0
	negl	d0
	movl	d7,d1
	andl	d0,d1
	cmpl	d7,d1
	beqs	TS3032			| Hoppa om det st{mmer


	| Avsluta med felkod -1
TS3030:
	moveq	#0xffffffff,d0		| Felkod -1
	bras	TS3031			| Avsluta rutinen


	| Ber{kna i vilken position "ettan" finns
TS3032:
	clrl	d6			| Antag position 0
	bras	TS3033

TS3034:
	lsrl	#1,d7
	addql	#1,d6

TS3033:
	btst	#0,d7			| Har vi hittat "ettan" ?
	beqs	TS3034			| Nej,

	movl	d6,d0			| Ja, returnera bit positionen

TS3031:
	moveml	(sp)+,#0xc0		| d6 d7
	unlk	a6
	rts


